import java.io.*;
import java.util.*;

public class tobi {
	public static void main(String[] args) {
		boolean visualize = (args.length > 0 && "visualize".equals(args[0]));
		Scanner sc = new Scanner(System.in);
		int numDays = sc.nextInt();
		int numPayedDays = sc.nextInt();
		int previous = -2 * numPayedDays;
		int streakStart = previous;
		int[] days = new int[numDays];
		Deque<Integer> payedDays = new LinkedList<Integer>();
		for (int i = 0; i < numPayedDays; i++) {
			payedDays.addLast(streakStart);
		}
		int maxD = 0;
		for (int i = 0; i < numDays; i++) {
			days[i] = sc.nextInt();
			maxD = Math.max(maxD, days[i]);
		}
		if (visualize) {
			System.out.println(numDays + " " + numPayedDays + " " + Math.max(444, (int)Math.sqrt(maxD)));
		}

		int maxi = 0;
		int pos = 0;
		for (int i = 0; i < numDays; i++) {
			int tmp = days[i];
			if (tmp == previous + 1) {
				// extend the current streak for free
			} else {
				int gap = tmp - previous - 1;
				if (gap <= numPayedDays) {
					// gap can be filled completely
					for (int j = 0; j < gap; j++) {
						int first = payedDays.pollFirst();
						payedDays.addLast(tmp - gap + j);
						streakStart = first + 1;
					}
				} else {
					// gap is too large
					payedDays.clear();
					for (int j = 0; j < numPayedDays; j++) payedDays.addLast(tmp - numPayedDays + j);
					streakStart = tmp - numPayedDays;
				}
			}
			if (maxi < tmp - streakStart + 1) {
				maxi = tmp - streakStart + 1;
				pos = streakStart;
			}
			previous = tmp;
		}
		if (visualize) {
			System.out.println(pos);
			for (int i = 0; i < numDays; i++) {
				System.out.print(days[i] + " ");
			}
			System.out.println("");
		}
		System.out.println(maxi);
	}
}
