#include <bits/stdc++.h>
using namespace std;

// O(N^3)

int n,m;

vector<vector<int>> cnt;
int get(int l1,int l2,int r1,int r2){
  if (l2<l1 or r2<r1) return 0;
  return cnt[l2][r2]
    -(l1?       cnt[l1-1][r2  ]: 0)
    -(r1?       cnt[l2  ][r1-1]: 0)
    +(l1 && r1? cnt[l1-1][r1-1]: 0);
}

vector<vector<pair<uint32_t,int>>> dp;

uint32_t solve(int l,int r){
  if (r<l) return 0;
  auto &res=dp[l][r]; if (res.first!=-1) return res.first;

  for (int x=l; x<=r; x++){
    uint32_t cost=
      + get(l,x-1, x+1,n-1)
      + get(0,x-1, x+1,r)
      - get(l,x-1, x+1,r);
    res=min(res,{
      cost+solve(l,x-1)+solve(x+1,r),
      x
    });
  }

  return res.first;
}

void backtrack(int l,int r,vector<int> &h,int height=0){
  if (r<l) return;
  h[dp[l][r].second]=height;
  backtrack(l,dp[l][r].second-1,h,height-1);
  backtrack(dp[l][r].second+1,r,h,height-1);
}

int main(){
  cin>>n>>m;
  dp.assign(n,vector<pair<uint32_t,int>>(n,{-1,-1}));
  cnt.assign(n+1,vector<int>(n+1));
  for (int i=0; i<m; i++){
    int a,b; cin>>a>>b; --a,--b; if (b<a) swap(a,b);
    ++cnt[a][b];
  }
  for (int i=0; i<=n; i++)
    for (int j=0; j<=n; j++)
      cnt[i][j]+=(i?cnt[i-1][j]:0)+(j?cnt[i][j-1]:0)-(i and j?cnt[i-1][j-1]:0);

  cout<<solve(0,n-1)+m<<endl;

  vector<int> res(n);
  backtrack(0,n-1,res);
  int depth=0; for (int i: res) depth=min(depth,i); for (auto &i: res) i+=1-depth;
  for (int i=0; i<n; i++) cout<<res[i]<<(i+1==n?'\n':' ');
}
