#include <bits/stdc++.h>
using namespace std;

// O(N^4)

vector<vector<pair<uint32_t,int>>> dp;
vector<pair<int,int>> paths;

uint32_t solve(int l,int r){
  if (r<l) return 0;
  auto &res=dp[l][r]; if (res.first!=-1) return res.first;

  for (int x=l; x<=r; x++){
    uint32_t cost=0;
    for (auto const &p: paths){
      if (p.first<x and x<p.second and (l<=p.first or p.second<=r)){
        ++cost;
      }
    }
    res=min(res,{
      cost+solve(l,x-1)+solve(x+1,r),
      x
    });
  }

  return res.first;
}

void backtrack(int l,int r,vector<int> &h,int height=0){
  if (r<l) return;
  h[dp[l][r].second]=height;
  backtrack(l,dp[l][r].second-1,h,height-1);
  backtrack(dp[l][r].second+1,r,h,height-1);
}

int main(){
  int n,m; cin>>n>>m;
  dp.assign(n,vector<pair<uint32_t,int>>(n,{-1,-1}));
  paths.assign(m,{});
  for (auto &i: paths){
    cin>>i.first>>i.second; --i.first, --i.second;
    if (i.second<i.first) swap(i.first,i.second);
  }
  cout<<solve(0,n-1)+m<<endl;

  vector<int> res(n);
  backtrack(0,n-1,res);
  int depth=0; for (int i: res) depth=min(depth,i); for (auto &i: res) i+=1-depth;
  for (int i=0; i<n; i++) cout<<res[i]<<(i+1==n?'\n':' ');
}
